/*
 * CLCLvOC \[XR[hHTMLɂ by YT
 * CLCLNakashima Tomoaki̒앨ł.
 */

#include "CLCLPlugin.h"
#include <dyaregexp.h>

/* HINSTANCE dll_instance; */

static char *convert(HWND window, char *format_file, char const *text);

/* DllMain */
#pragma argsused
int WINAPI DllMain(HINSTANCE hInstance, DWORD fdwReason, PVOID pvReserved) 
{
/*
	switch(fdwReason) 
	{
	case DLL_PROCESS_ATTACH:
		dll_instance = hInstance;
		break;
	case DLL_PROCESS_DETACH:
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	}
*/
	return TRUE;
}

/* 擾 */
#pragma argsused
__declspec(dllexport) BOOL CALLBACK get_tool_info(const HWND hWnd, const int index, TOOL_GET_INFO *tgi)
{
	switch (index) {
	case 0:
		lstrcpy(tgi->title, TEXT("src2html"));
		lstrcpy(tgi->func_name, TEXT("src2html"));
		lstrcpy(tgi->cmd_line, TEXT(""));
		tgi->call_type = CALLTYPE_MENU | CALLTYPE_VIEWER;
		return TRUE;
	case 1:
		lstrcpy(tgi->title, TEXT("src2html:Rs["));
		lstrcpy(tgi->func_name, TEXT("src2html_copy"));
		lstrcpy(tgi->cmd_line, TEXT(""));
		tgi->call_type = CALLTYPE_MENU | CALLTYPE_VIEWER;
		return TRUE;
	default:
		return FALSE;
	}
}

__declspec(dllexport) int CALLBACK src2html(const HWND hWnd, TOOL_EXEC_INFO *tei, TOOL_DATA_INFO *tdi)
{
	TOOL_DATA_INFO *info;
	for(info = tdi; info != NULL; info = info->next)
	{
		DATA_INFO *data;
		data = (DATA_INFO *)SendMessage(hWnd, WM_ITEM_GET_FORMAT_TO_ITEM, (WPARAM)TEXT("TEXT"), (LPARAM)info->di);
		if(data != NULL && data->data != NULL)
		{
			char *mem, *r;
			if((mem = GlobalLock(data->data)) == NULL) return TOOL_ERROR;
			r = convert(hWnd, tei->cmd_line, mem);
			GlobalUnlock(data->data);
			if(r == NULL) return TOOL_ERROR;
			GlobalFree(data->data);
			data->data = GlobalAlloc(GMEM_MOVEABLE, lstrlen(r) + 1);
			lstrcpy(GlobalLock(data->data), r);
			GlobalUnlock(data->data);
			HeapFree(GetProcessHeap(), 0, r);
		}
	}
	return TOOL_SUCCEED | TOOL_DATA_MODIFIED;
}

__declspec(dllexport) int CALLBACK src2html_copy(const HWND hWnd, TOOL_EXEC_INFO *tei, TOOL_DATA_INFO *tdi)
{
	TOOL_DATA_INFO *info;
	for(info = tdi; info != NULL; info = info->next)
	{
		DATA_INFO *data;
		data = (DATA_INFO *)SendMessage(hWnd, WM_ITEM_GET_FORMAT_TO_ITEM, (WPARAM)TEXT("TEXT"), (LPARAM)info->di);
		if(data != NULL && data->data != NULL)
		{
			HGLOBAL g;
			char *mem, *r;
			if((mem = GlobalLock(data->data)) == NULL) return TOOL_ERROR;
			r = convert(hWnd, tei->cmd_line, mem);
			GlobalUnlock(data->data);
			if(r == NULL) return TOOL_ERROR;
			g = GlobalAlloc(GMEM_MOVEABLE, lstrlen(r) + 1);
			lstrcpy(GlobalLock(g), r);
			GlobalUnlock(g);
			/* Nbv{[hɑ */
			if(OpenClipboard(hWnd))
			{
				if(EmptyClipboard())
				{
					if(SetClipboardData(CF_TEXT, g)) g = NULL;
				}
				CloseClipboard();
			}
			if(data != NULL) GlobalFree(g);
			HeapFree(GetProcessHeap(), 0, r);
		}
	}
	return TOOL_SUCCEED;
}

typedef struct 
{
	char tag_class[256];
} mode;

typedef struct
{
	regexp expression;
	int mode;
} exp;

static bool read_format(HWND window, mode* modes, int *mode_count, exp *exps, int *exp_count, char *format_file)
{
	DWORD R;
	int size, line, now_mode;
	char *buffer, *p, *w;
	HANDLE file = CreateFile(format_file, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
	if(file == INVALID_HANDLE_VALUE)
	{
		MessageBox(window, "t@Cǂ߂܂", "src2html", MB_ICONERROR);
		return false;
	}
	size = GetFileSize(file, NULL);
	buffer = HeapAlloc(GetProcessHeap(), 0, size);
	ReadFile(file, buffer, size, &R, NULL);
	CloseHandle(file);
	
	now_mode = -1;
	line = 1;
	p = buffer;
	while(p < buffer + size)
	{
		if(*p == '\t')
		{
			++p;
			w = p;
			while(*w != 10 && *w != 13 && w < buffer + size) ++w;
			
			if(regexp_compile(&exps[*exp_count].expression, p, w - p, encoding_locale, 0))
			{
				exps[*exp_count].mode = now_mode;
				++(*exp_count);
			}
			else
			{
				char message[1024];
				wsprintf(message, "K\G[(%ds)", line);
				MessageBox(window, message, "src2html", MB_ICONERROR);
				return false;
			}
			p = w;
		}
		else if(*p == 13)
		{
			++p;
		}
		else if(*p == 10)
		{
			++p;
			++line;
		}
		else
		{
			w = p;
			while(*w != 10 && *w != 13 && w < buffer + size) ++w;
			
			if(*p == '*' && w - p == 1)
				now_mode = -1;
			else
			{
				now_mode = *mode_count;
				
				MoveMemory(modes[now_mode].tag_class, p, w - p);
				modes[now_mode].tag_class[w - p] = '\0';
				++(*mode_count);
			}
			p = w;
		}
	}
	
	HeapFree(GetProcessHeap(), 0, buffer);
	return true;
}

static void finalize_format(exp* exps, int exp_count)
{
	int i;
	for(i = exp_count; i >= 0; --i)
		regexp_finalize(&exps[i].expression);
}

static void hstrcat(char **dest, char const *value, int value_length)
{
	int dest_length = lstrlen(*dest);
	*dest = HeapReAlloc(GetProcessHeap(), 0, *dest, dest_length + value_length + 1);
	MoveMemory(*dest + dest_length, value, value_length);
	*(*dest + dest_length + value_length) = '\0';
}

static void put_char(char **dest, char value)
{
	if(value == '&')
		hstrcat(dest, "&amp;", 5);
	else if(value == '<')
		hstrcat(dest, "&lt;", 4);
	else if(value == '>')
		hstrcat(dest, "&gt;", 4);
	else if(value == '\t')
		hstrcat(dest, "  ", 2);
	else
		hstrcat(dest, &value, 1);
}

#pragma argsused
static char *convert(HWND window, char *format_file, char const *text)
{
	char *result = NULL;
	mode modes[64];
	exp exps[1024];
	int mode_count = 0;
	int exp_count = 0;
	if(read_format(window, modes, &mode_count, exps, &exp_count, format_file))
	{
		int mode = -1;
		char const *p;
		match_source source;
		source.start = text;
		source.end = text + lstrlen(text);
		source.on_label = NULL;
		source.ex = 0;

		while(source.end > source.start && (*(source.end - 1) == 10 || *(source.end - 1) == 13))
			--source.end;

		result = HeapAlloc(GetProcessHeap(), 0, 32);
		lstrcpy(result, "<pre class=\"code\">\xD\xA");
		
		p = source.start;
		while(p < source.end)
		{
			char const *pre = p;
			int i;
			for(i = 0; i < exp_count; ++i)
			{
				if(regexp_match(&exps[i].expression, &source, &p))
				{
					char const *j;
					if(exps[i].mode != mode)
					{
						if(mode >= 0) hstrcat(&result, "</span>", 7);
						mode = exps[i].mode;
						if(mode >= 0)
						{
							hstrcat(&result, "<span class=\"", 13);
							hstrcat(&result, modes[mode].tag_class, lstrlen(modes[mode].tag_class));
							hstrcat(&result, "\">", 2);
						}
					}
					
					for(j = pre; j < p; ++j)
						put_char(&result, *j);

					goto next;
				}
			}
			put_char(&result, *p);
			++p;
next:
		}
		if(mode >= 0) hstrcat(&result, "</span>", 7);
		hstrcat(&result, "\xD\xA</pre>\xD\xA", 10);
	}

	finalize_format(exps, exp_count);
	return result;
}
